/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exceptions;

import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import javax.swing.JOptionPane;

/**
 * Test how the exception is propagated all the
 * way back to main
 * @author hajo
 */
public class TestException {

    public static void main(String args[]) {
        TestException e = new TestException();

        // Here we handle any exception
        try {
            e.doIt();
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage());
            // After this the exception is handled, program will continue
            // here ...
        }
        // .. and then here ...
        System.out.println("program finished");
    }

    // Method doesn't handle exception send to caller (using throws)
    private void doIt() throws IOException {
        doOther();
    }

    // Method doesn't handle exception send to caller (using throws)
    private void doOther() throws IOException {
        doYetOther();
    }

    // Method doesn't handle exception send to caller (using throws)
    private void doYetOther() throws IOException {
        File f = new File("doesntExist");
        Scanner s = new Scanner(f);    // This will throw an exception

    }

}
