package recursion;

/**
 * Simple use of recursion
 * For real use see Towers of Hanoi
 *
 * @author hajo
 */
public class TestSimpleRecursion {

    private static int sum(int index, int[] values) {
        if (index == values.length - 1) {
            //System.out.println("Adding last value " + values[index] );
            return values[index];
        } else {
            //System.out.println("Adding " + values[index] );
            return values[index] + sum(index + 1, values);
        }
    }

    public static void main(String[] args) {
        int[] values = new int[]{1, 2, 3, 4, 5};
        int total = sum(0, values);
        System.out.println("Total is " + total);
    }
}
