package animation;

import java.awt.GridLayout;
import java.awt.HeadlessException;
import javax.swing.JFrame;
import javax.swing.WindowConstants;

/**
 * Fancy graphics
 * @author hajo
 */
public class MainFrame extends JFrame {

    public MainFrame(String title) throws HeadlessException {
        super(title);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setLocationRelativeTo(null);
        setSize(500, 500);
        setLayout(new GridLayout(2, 1));

        add(new FancyPanel());
        add(new AnimationPanel());
        setVisible(true);
    }

    public static void main(String[] args) {
        new MainFrame("Test animation");
    }
}
