package filehandling;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Testing file input output (= IO )
 * 
 * 
 *  **** Check if there is a file, createdByReaderWriter.txt, on disk ****
 *  Inspect content of file
 *
 * @author hajo
 */
public class TestReaderWriter {

    public static void main(String args[]) throws IOException {
        List<ClassToSave> objects = new ArrayList<>();
        for (int i = 0; i < 20; i++) {
            objects.add(new ClassToSave(i, "s" + i));
        }
        new ReaderWriter().save("createdByReaderWriter.txt", objects);
        objects.clear();
        objects = new ReaderWriter().open("createdByReaderWriter.txt");
        for (ClassToSave o : objects) {
            System.out.println(o);
        }
    }
}
