package visualtowersofhanoi;

public class HanoiText {

    public static int move(int n, int from, int to, int aux) {
        // Flytta n brickor från pinne from till pinne to
        // med pinne aux som hjälppinne och aldrig med en större
        // bricka ovanpå en mindre.
        if (n > 0) {
            int i = move(n - 1, from, aux, to);
            System.out.println("Flytta från " + from + " till " + to);
            int j = move(n - 1, aux, to, from);
            return i + j + 1;
        }
        return 0;
    }

    public static void main(String[] args) {
        int nrOfDiscs;
        if (args.length == 0) {
            nrOfDiscs = 5;
        } else {
            nrOfDiscs = Integer.parseInt(args[0]);
        }
        int i = move(nrOfDiscs, 1, 2, 3);
        System.out.println("Antal drag = " + i);
    }
}