package visualtowersofhanoi;

import javax.swing.*;

public class Main {

    public static void main(String[] args) {
        int nrOfDiscs; 
        if( args.length == 0){
            nrOfDiscs = 5;
        }else{
            nrOfDiscs = Integer.parseInt(args[0]);
        }
	JFrame f = new JFrame("Towers of Hanoi");
	HanoiModel model = new HanoiModel(nrOfDiscs); 
	HanoiView view = new HanoiView(model);
	f.getContentPane().add(view);
	f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	f.pack(); 
	f.setVisible(true);
    }
}

    